#include "List.h"

class SortedList: public List
{
public:
// constructors and destructor:
   SortedList();
   SortedList(const SortedList& sList);
   virtual ~SortedList();

// new operations:
   virtual void sortedInsert(ListItemType newItem)
                             throw(ListException);
   virtual void sortedRemove(ListItemType anItem)
                             throw(ListException);
   virtual int locatePosition(ListItemType anItem,
                              bool& isPresent);
};  // end SortedList class